'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = NumberSchema;

var _inherits = require('./utils/inherits');

var _inherits2 = _interopRequireDefault(_inherits);

var _mixed = require('./mixed');

var _mixed2 = _interopRequireDefault(_mixed);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function NumberSchema() {
  if (!(this instanceof NumberSchema)) {
    return new NumberSchema();
  }

  _mixed2.default.call(this, { type: 'number' });
}

(0, _inherits2.default)(NumberSchema, _mixed2.default, {
  _getJSONSchema: function _getJSONSchema() {
    var opts = this._getOptions();

    var schema = void 0,
        type = 'number';

    if (opts.isInteger === true) {
      type = 'integer';
    }

    schema = {
      type: type
    };

    if (opts.multipleOf != null) {
      schema.multipleOf = opts.multipleOf;
    }

    if (opts.minimum != null) {
      schema.minimum = opts.minimum;
    }

    if (opts.maximum != null) {
      schema.maximum = opts.maximum;
    }

    if (opts.exclusiveMinimum != null) {
      schema.exclusiveMinimum = opts.exclusiveMinimum;
    }

    if (opts.exclusiveMaximum != null) {
      schema.exclusiveMaximum = opts.exclusiveMaximum;
    }

    return schema;
  },
  integer: function integer() {
    this._setOption('isInteger', true);
    return this.instance();
  },
  multipleOf: function multipleOf(value) {
    this._setOption('multipleOf', value);
    return this.instance();
  },
  minimum: function minimum(value) {
    this._setOption('minimum', value);
    return this.instance();
  },
  maximum: function maximum(value) {
    this._setOption('maximum', value);
    return this.instance();
  },
  exclusiveMinimum: function exclusiveMinimum(value) {
    this._setOption('exclusiveMinimum', value);
    return this.instance();
  },
  exclusiveMaximum: function exclusiveMaximum(value) {
    this._setOption('exclusiveMaximum', value);
    return this.instance();
  }
});
module.exports = exports['default'];