'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = StringSchema;

var _inherits = require('./utils/inherits');

var _inherits2 = _interopRequireDefault(_inherits);

var _mixed = require('./mixed');

var _mixed2 = _interopRequireDefault(_mixed);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function StringSchema() {
  if (!(this instanceof StringSchema)) {
    return new StringSchema();
  }

  _mixed2.default.call(this, { type: 'string' });
}

(0, _inherits2.default)(StringSchema, _mixed2.default, {
  _getJSONSchema: function _getJSONSchema() {
    var opts = this._getOptions();

    var schema = {
      type: 'string'
    };

    if (opts.minLength != null) {
      schema.minLength = opts.minLength;
    }

    if (opts.maxLength != null) {
      schema.maxLength = opts.maxLength;
    }

    if (opts.pattern != null) {
      schema.pattern = opts.pattern;
    }

    if (opts.format != null) {
      schema.format = opts.format;
    }

    return schema;
  },
  minLength: function minLength(value) {
    this._setOption('minLength', value);
    return this.instance();
  },
  maxLength: function maxLength(value) {
    this._setOption('maxLength', value);
    return this.instance();
  },
  pattern: function pattern(_value) {
    var value = _value;

    if (value instanceof RegExp) {
      value = value.toString().slice(1, -1);
    }

    this._setOption('pattern', value);
    return this.instance();
  },
  format: function format(value) {
    this._setOption('format', value);
    return this.instance();
  }
});
module.exports = exports['default'];